<?php

# Download CryptoPhoto PHP lib from https://cryptophoto.com/admin/api
include("CryptoPhotoUtils.php");

$server      = "https://cryptophoto.com";
$private_key = "xxx"; # Your CryptoPhoto Private API Key
$public_key  = "yyy"; # Your CryptoPhoto Public API Key
$salt        = "random-salt-string";
$uid         = "userId"; # Your users internal ID

$do_login = 1;
$do_cp_authentication = 0;
$do_success = 0;
$error = '';
$sid = '';                         

if (isset($_POST["username"])) {
  // check user name and password
  if ($_POST["username"] == "demo") {
    // all OK
    // do CryptoPhoto authentication
    $do_cp_authentication = 1;
    $do_login = 0;

  }
} 
else if (isset($_POST['cryptophoto'])) {

  $do_login = 0; $do_cp_authentication = 1;
 
  // check for POSTed CP Token codes
  if ($_POST['token_selector'] &&
     (($_POST['token_response_field_row'] && $_POST['token_response_field_col']) || $_POST['cp_phc']) ) {

    $cp = new CryptoPhotoUtils($server, $private_key, $public_key, sha1($uid . $salt));

    $cp->verify_response($_POST['token_selector'], $_POST['token_response_field_row'], 
          $_POST['token_response_field_col'], $_POST['cp_phc'], $_SERVER['REMOTE_ADDR']);

    if ($cp->is_valid) {// CP Token codes verified
      $do_success = 1;
      $do_cp_authentication = 0;
    } else {
      $error = 'Invalid codes';
    }
  } else {
    $error = 'Missing required codes. Invalid authentication';
  }
}

if ($do_cp_authentication) {
  $cp = new CryptoPhotoUtils($server, $private_key, $public_key, sha1($uid . $salt));

  $cp->start_session($_SERVER['REMOTE_ADDR'], true);

  if ($cp->is_valid) {
    if ($cp->has_token) {
      $sid = $cp->sid;
    } else {
      $do_success = 1;
      $do_cp_authentication = 0;
    }
  } else {
    $error = $cp->error . ( $cp->errdesc ? ' ' . $cp->errdesc : '' );
  }
}


?><!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>User Login</title>
</head>

<body style="text-align:center">
  <h2>Login</h2>
  <form action="login.php" method="post">
    <p><?php if($error) { ?>Error: <?php echo $error ?><?php } ?></p>

<?php if ($do_login) { ?>

    Username: <input type="text" name="username" value="demo"><br>
    <input type="submit" value="Login">

<?php } else if ($do_cp_authentication) { ?>

    <input type='hidden' name='cryptophoto'>
    <div id='cp_widget' style='margin: 10px auto;width:300px'>Loading...</div>
    <input type='submit' value='Continue'>

<?php } else if ($do_success) { ?>

  <p>You have successfully login.</p>

<?php } ?>
</form>

<?php if($do_cp_authentication) { ?>

<script type='text/javascript'
        src='<?php echo $server ?>/api/challenge?sd=<?php echo $sid ?>'>
</script>

<?php } ?>

</body>
</html>